/***************************************************************************
                          DistributedAdaptiveGrid.hpp  -  description
                             -------------------
    begin                : July 07, 2018
    copyright            : (C) 2018 by Tomas Oberhuber
    email                : tomas.oberhuber@fjfi.cvut.cz
 ***************************************************************************/

/* See Copyright Notice in tnl/Copyright */

#pragma once

#include <cstdlib>
#include <TNL/Communicators/MpiCommunicator.h>
#include <TNL/Meshes/DistributedMeshes/DistributedGrid.h>

#ifdef HAVE_ADAPTIVE_GRID
#include <TNL/Meshes/GridAdaptive.h>
#endif

namespace TNL {
   namespace Meshes {
      namespace DistributedMeshes {

template<int Dimension, typename Real, typename Device, typename Index >
DistributedMesh< GridA< Dimension, Real, Device, Index > >::
DistributedMesh()
 : domainDecomposition( 0 ), isSet( false ) {}

template<int Dimension, typename Real, typename Device, typename Index >
DistributedMesh< GridA< Dimension, Real, Device, Index > >::
~DistributedMesh()
{
}


template<int Dimension, typename Real, typename Device, typename Index >
void
DistributedMesh< GridA< Dimension, Real, Device, Index > >::
configSetup( Config::ConfigDescription& config )
{
}

template<int Dimension, typename Real, typename Device, typename Index >
bool
DistributedMesh< GridA< Dimension, Real, Device, Index > >::
setup( const Config::ParameterContainer& parameters,
       const String& prefix )
{
   return true;
}

template< int Dimension, typename Real, typename Device, typename Index >     
void
DistributedMesh< GridA< Dimension, Real, Device, Index > >::
setDomainDecomposition( const CoordinatesType& domainDecomposition )
{
}

template< int Dimension, typename Real, typename Device, typename Index >     
const typename DistributedMesh< GridA< Dimension, Real, Device, Index > >::CoordinatesType&
DistributedMesh< GridA< Dimension, Real, Device, Index > >::
getDomainDecomposition() const
{
}

template< int Dimension, typename Real, typename Device, typename Index >     
template< typename CommunicatorType >
void
DistributedMesh< GridA< Dimension, Real, Device, Index > >::
setGlobalGrid( const GridType &globalGrid )
{
}

template< int Dimension, typename Real, typename Device, typename Index >     
void
DistributedMesh< GridA< Dimension, Real, Device, Index > >::
setOverlaps( const SubdomainOverlapsType& lower,
             const SubdomainOverlapsType& upper)
{
}


template< int Dimension, typename Real, typename Device, typename Index >
void
DistributedMesh< GridA< Dimension, Real, Device, Index > >::
setupGrid( GridType& grid)
{
};

template< int Dimension, typename Real, typename Device, typename Index >     
const typename DistributedMesh< GridA< Dimension, Real, Device, Index > >::CoordinatesType&
DistributedMesh< GridA< Dimension, Real, Device, Index > >::
getSubdomainCoordinates() const
{
}

template< int Dimension, typename Real, typename Device, typename Index >     
const typename DistributedMesh< GridA< Dimension, Real, Device, Index > >::PointType&
DistributedMesh< GridA< Dimension, Real, Device, Index > >::
getLocalOrigin() const
{
}

template< int Dimension, typename Real, typename Device, typename Index >     
const typename DistributedMesh< GridA< Dimension, Real, Device, Index > >::PointType&
DistributedMesh< GridA< Dimension, Real, Device, Index > >::
getSpaceSteps() const
{
}
   
template< int Dimension, typename Real, typename Device, typename Index >     
bool
DistributedMesh< GridA< Dimension, Real, Device, Index > >::
isDistributed() const
{
};

template< int Dimension, typename Real, typename Device, typename Index >     
bool
DistributedMesh< GridA< Dimension, Real, Device, Index > >::
isBoundarySubdomain() const
{
}

template< int Dimension, typename Real, typename Device, typename Index >     
const typename DistributedMesh< GridA< Dimension, Real, Device, Index > >::CoordinatesType&
DistributedMesh< GridA< Dimension, Real, Device, Index > >::
getLowerOverlap() const
{
};

template< int Dimension, typename Real, typename Device, typename Index >     
const typename DistributedMesh< GridA< Dimension, Real, Device, Index > >::CoordinatesType&
DistributedMesh< GridA< Dimension, Real, Device, Index > >::
getUpperOverlap() const
{
};

template< int Dimension, typename Real, typename Device, typename Index >     
const typename DistributedMesh< GridA< Dimension, Real, Device, Index > >::CoordinatesType&
DistributedMesh< GridA< Dimension, Real, Device, Index > >::
getLocalSize() const
{
}

template< int Dimension, typename Real, typename Device, typename Index >     
const typename DistributedMesh< GridA< Dimension, Real, Device, Index > >::CoordinatesType&
DistributedMesh< GridA< Dimension, Real, Device, Index > >::
getGlobalSize() const
{
}

template< int Dimension, typename Real, typename Device, typename Index >     
const typename DistributedMesh< GridA< Dimension, Real, Device, Index > >::GridType&
DistributedMesh< GridA< Dimension, Real, Device, Index > >::
getGlobalGrid() const
{
}

template< int Dimension, typename Real, typename Device, typename Index >     
const typename DistributedMesh< GridA< Dimension, Real, Device, Index > >::CoordinatesType&
DistributedMesh< GridA< Dimension, Real, Device, Index > >::
getGlobalBegin() const
{
}

template< int Dimension, typename Real, typename Device, typename Index >     
const typename DistributedMesh< GridA< Dimension, Real, Device, Index > >::CoordinatesType&
DistributedMesh< GridA< Dimension, Real, Device, Index > >::
getLocalGridSize() const
{
}

template< int Dimension, typename Real, typename Device, typename Index >     
const typename DistributedMesh< GridA< Dimension, Real, Device, Index > >::CoordinatesType&
DistributedMesh< GridA< Dimension, Real, Device, Index > >::
getLocalBegin() const
{
}

template< int Dimension, typename Real, typename Device, typename Index >      
   template< int EntityDimension >
Index
DistributedMesh< GridA< Dimension, Real, Device, Index > >::
getEntitiesCount() const
{
}

template< int Dimension, typename Real, typename Device, typename Index >       
   template< typename Entity >
Index
DistributedMesh< GridA< Dimension, Real, Device, Index > >::
getEntitiesCount() const
{
}

template< int Dimension, typename Real, typename Device, typename Index >    
void 
DistributedMesh< GridA< Dimension, Real, Device, Index > >::
setCommunicationGroup(void * group)
{
}

template< int Dimension, typename Real, typename Device, typename Index >    
void *
DistributedMesh< GridA< Dimension, Real, Device, Index > >::
getCommunicationGroup() const
{
}

template< int Dimension, typename Real, typename Device, typename Index >    
int
DistributedMesh< GridA< Dimension, Real, Device, Index > >::
getRankOfProcCoord(const CoordinatesType &nodeCoordinates) const
{
}

template< int Dimension, typename Real, typename Device, typename Index >    
bool
DistributedMesh< GridA< Dimension, Real, Device, Index > >::
isThereNeighbor(const CoordinatesType &direction) const
{
}

template< int Dimension, typename Real, typename Device, typename Index >    
void
DistributedMesh< GridA< Dimension, Real, Device, Index > >::
setupNeighbors()
{
}

template< int Dimension, typename Real, typename Device, typename Index >   
const int*
DistributedMesh< GridA< Dimension, Real, Device, Index > >::
getNeighbors() const
{
    TNL_ASSERT_TRUE(this->isSet,"DistributedGrid is not set, but used by getNeighbors");
    return this->neighbors;
}

template< int Dimension, typename Real, typename Device, typename Index >   
const int*
DistributedMesh< GridA< Dimension, Real, Device, Index > >::
getPeriodicNeighbors() const
{
    TNL_ASSERT_TRUE(this->isSet,"DistributedGrid is not set, but used by getNeighbors");
    return this->periodicNeighbors;
}

template< int Dimension, typename Real, typename Device, typename Index >
    template<typename CommunicatorType, typename DistributedGridType >
bool 
DistributedMesh< GridA< Dimension, Real, Device, Index > >::
SetupByCut(DistributedGridType &inputDistributedGrid, 
         Containers::StaticVector<Dimension, int> savedDimensions, 
         Containers::StaticVector<DistributedGridType::getMeshDimension()-Dimension,int> reducedDimensions, 
         Containers::StaticVector<DistributedGridType::getMeshDimension()-Dimension,IndexType> fixedIndexs)
{
   return false;
}

template< int Dimension, typename Real, typename Device, typename Index >
String
DistributedMesh< GridA< Dimension, Real, Device, Index > >::
printProcessCoords() const
{
};

template< int Dimension, typename Real, typename Device, typename Index >
String
DistributedMesh< GridA< Dimension, Real, Device, Index > >::
printProcessDistr() const
{
}

template< int Dimension, typename Real, typename Device, typename Index >
void
DistributedMesh< GridA< Dimension, Real, Device, Index > >::
writeProlog( Logger& logger )
{
}           

template< int Dimension, typename Real, typename Device, typename Index >    
void
DistributedMesh< GridA< Dimension, Real, Device, Index > >::
print( std::ostream& str ) const
{
}

      } //namespace DistributedMeshes
   } // namespace Meshes
} // namespace TNL
